#include <PalmOS.h>
#include <VFSMgr.h>

/************************************************/
/* PalmOSGUI_dbfile.h                           */
/* A small package to unify handling of data    */
/* manager databases and VFS .pdb's             */
/************************************************/

typedef struct DbFile {
	Boolean external;
	union {
		FileRef f;
		DmOpenRef db;
	} u;
} DbFile;

void DbFileFromDbRef(DmOpenRef db, DbFile *dbf);
void DbFileFromFileRef(FileRef f, DbFile *dbf);
void DbFileClose(DbFile *dbf);
Err DbFileInfo(DbFile *dbf, UInt32 *type, UInt32 *app, UInt16 *n);
Err DbFileGetRecord(DbFile *dbf, UInt16 idx, MemHandle *h);
Err DbFileReleaseRecord(DbFile *dbf, UInt16 idx, MemHandle h, Boolean b);

