//
//  T64Handler.java
//  C64Palmer
//
//  Created by Johan Forsberg on Thu Aug 28 2003.
//  Copyright (c) 2003 Johan Forsberg. All rights reversed.
//

import java.io.*;
import javax.swing.*;

public class T64Handler {
    static byte template[][]=new byte[2][];
    static int MEM1=0xe0; 
    static int PC=0x8406;
    
    void findSnapshot() {
	return;
/*	if (template[0]!=null) return;
	
	try {
	    JFileChooser fc=null;
	    File f = new File("SnapshotTemplate1.bin");
	    if (!f.exists()) {
		fc=new JFileChooser();
		if (fc.showOpenDialog(C64Palmer.theWindow)==JFileChooser.CANCEL_OPTION)
			return;
		f=fc.getSelectedFile();
		if (f==null) return;
	    }
	    template[0]=new byte[(int)f.length()];
	    FileInputStream fis=new FileInputStream(f);
	    int offs=0, read=0;
	    while ((read=fis.read(template[0],offs,template[0].length-offs))>=0) {
		offs+=read;
		if (offs>=template[0].length) break;
	    }
	    fis.close();
	    byte b[]=template[0];
	    f = new File("SnapshotTemplate2.bin");
	    if (!f.exists()) {
		if (fc==null) fc=new JFileChooser();
		if (fc.showOpenDialog(C64Palmer.theWindow)==JFileChooser.CANCEL_OPTION)
			return;
		f=fc.getSelectedFile();
		if (f==null) return;
	    }
	    template[1]=new byte[(int)f.length()];
	    fis=new FileInputStream(f);
	    offs=0; read=0;
	    while ((read=fis.read(template[1],offs,template[1].length-offs))>=0) {
		offs+=read;
		if (offs>=template[1].length) break;
	    }
	    b=template[1];
	    fis.close();
	} catch (Exception x) {
	    template[0]=template[1]=null;
	    System.err.println("Can't load template snapshot!");
	}
	*/
    }
    public T64Handler() {
	findSnapshot();
    }
    
    public PDBItem handle(File f) {
        try {
            byte b[]=new byte[(int)f.length()];
            FileInputStream fis=new FileInputStream(f);
            fis.read(b);
            return handle(f.getName(), b);
        } catch (Exception x) {
            x.printStackTrace();
            return null;
        }
    }
    // Handle a .t64 file. May become a snapshot.
    public PDBItem handle(String name, byte buf[]) {
	PDBItem converted=trySnapshot(name, buf);
        
	if (converted!=null) return converted;
	
	return new PDBItem(name, buf);
    }
    PDBItem trySnapshot(String name, byte buf[]) {
	// Another "smart conversion"
	// If this .t64 contains just 1 file that loads to 2049 and the basic program
	// begins with "SYS XXXXX", then this is start-from-basic machine
	// code program, and we should be able to construct a snapshot file using
	// a template snapshot of a C=64 idling in Basic.
	
	// This isn't working...
	return null;
	/*
	findSnapshot();
        try {
            int files=(((int)buf[34])&0xff) | ((buf[35]<<8)&0xff00);
            int type=((int)buf[64])&0xff, d64type=((int)buf[65])&0xff;
            int offs=((buf[75]<<24)&0xff000000) | ((buf[74]<<16)&0xff0000) |
		((buf[73]<<8)&0xff00) | (((int)buf[72])&0xff);
            int start=(((int)buf[66])&0xff) | ((buf[67]<<8)&0xff00);
            int end=(((int)buf[68])&0xff) | ((buf[69]<<8)&0xff00);
	    int len=end-start+1;
	    int header=36;
	    int i, sys;

            if (files != 1) {
                System.err.println("More than one file");
                return null;
            }
            if (type != 1) {
                System.err.println("Can't handle .t64 file of type "+type);
                return null;
            }
            if (d64type == 0) {
                System.err.println("The 1541 type is 0, this can't be a program?");
                return null;
            }
	    if (start != 2049) {
                System.err.println("This file starts at "+start+", not 2049.");
                return null;
            }
	    if (len > 65526-2049) {
	        System.err.println("Err.. That won't fit in 64 kB (file is "+len+"bytes)");
                return null;
	    }
	    // So, we have reasonable lone basic program.
	    // Try a new tack, simply set pc to the "RUN" entrypoint.
	    sys=0xa871;
	    /*
	    // Check if it does a SYS, first thing.
	    
	    // C=64 basic programs start at 2049 with a 'line'.
	    // A line is:
	    // short nextLine	(reverse byte order)
	    // short lineNumber	(maybe some flags also?)
	    // byte basicTokensAndText[] (null-terminated)
	    // A basic token is anything>=128, all else is ascii.
	    // The token for "SYS" is 0x9e
	    for (i=offs+4; buf[i]==' '; i++);
	    if (buf[i]!=(byte)0x9e) {
		System.err.println("Program starts with token "+buf[i]+", not SYS.");
		return null;
	    }
	    for (i++; buf[i]==' '; i++);
	    if (buf[i]=='(') {
		i++;
	    }
	    for (; buf[i]==' '; i++);
	    if (buf[i]<'0' || buf[i]>'9') {
		System.err.println("SYS to variable (beginning with '"+((char)buf[i])+"').");
		return null;
	    }
	    for (sys=0; buf[i]>='0' && buf[i]<='9'; i++)
		sys=sys*10+buf[i]-'0';
	    
	    for (i++; b[i]==' '; i++);
	    if (b[i]!=0 b[i]!=')') {
	        System.err.printf("SYS "+sys+" seems to be followed by an expression?");
		return null;
	    }
	    *
	    
	    byte p1[]=new byte [template[0].length];
	    byte p2[]=new byte [template[1].length];
	    System.arraycopy(template[0], 0, p1, 0, template[0].length);
	    System.arraycopy(template[1], 0, p2, 0, template[1].length);
	    
	    // The first part of the snapshot ENDS with 32 kB of ram (at MEM1)
	    // The second part starts with the other 32kB ram.
	    
	    // Fill in memory
	    for (i=2049; i<len && i<(1<<15); i++)
		p1[header+MEM1+i]=buf[offs+i-2049];
	    for (; i<len; i++)
		p2[header+i-(1<<15)]=buf[offs+i-2049];
	    // Set pc
	    p2[header+PC]=(byte)sys;
	    p2[header+PC+1]=(byte)(sys>>8);
	    name=name.substring(0, name.length()-4)+".snp";
	    for (i=0; i<32; i++)
		if (i<name.length())
			p1[i+4]=p2[i+4]=(byte)name.charAt(i);
		else
			p1[i+4]=p2[i+4]=0;
	    return new PDBItem(name, p1, p2);
	} catch (Exception x) {
            x.printStackTrace();
        }
        return new PDBItem(name, buf);
	*/
    }
    
    // Handle a raw C=64 PRG file.
    public PDBItem handlePRG(String name, byte c64name[], byte buf[]) {
        ByteArrayOutputStream baos=new ByteArrayOutputStream();
        String hdr="C64S tape image file";
        int i;
        
        for (i=0; i<32; i++)
	    if (i<hdr.length())
	        baos.write((byte)hdr.charAt(i));
            else
	        baos.write(0);
		
	baos.write(1); baos.write(1); // format version		@ 32
        baos.write(1); baos.write(0); // max number of files	@ 34
        baos.write(1); baos.write(0); // number of files	@ 36
        baos.write(0); baos.write(0); // Unused			@ 38
        for (i=0; i<24; i++) // Tape name			@ 40
            if (i<name.length())
                baos.write((byte) name.charAt(i));
            else
                baos.write(0);
                
        // File info 1 starts
        baos.write(1);    // File type=normal			@ 64
        baos.write(0x82); // D64 file type (82=PRG)
	int start=(((int)buf[0])&0xff) | ((buf[1]<<8)&0xff00);
        baos.write((byte)start);
	baos.write((byte)(start>>8)); // load address		@ 66
        // end address is last memory byte affected, ie. start+length-1
	int end=start+buf.length-3;
        baos.write((byte)end);
	baos.write((byte)(end>>8));   // end address		@ 68
        baos.write(0); baos.write(0); // Unused			@ 70
        baos.write(0x60); baos.write(0);
	baos.write(0); baos.write(0); // Offset of data in .t64 @ 72
        baos.write(0); baos.write(0); // Unused			@ 76
        baos.write(0); baos.write(0); // Unused			@ 78
        for (i=0; i<16; i++) // Filename, PETASCII (' ' instead of 0xa0) @ 80
            if (c64name[i]==0xa0)
                baos.write((byte)' ');
            else
                baos.write(c64name[i]);
	// Other file infos could follow @ 96 (but don't, in this case)
	
	// File data
        for (i=2; i<buf.length; i++) // Skip the load address
            baos.write(buf[i]);
        
	if (name.charAt(name.length()-4)=='.')
		name=name.substring(0, name.length()-4)+".t64";
        return handle(name, baos.toByteArray());
    }
}
