#ifndef _PALMPOSIX_H
#define _PALMPOSIX_H

//#include <PalmOS.h>
//#include <stdarg.h>

#define Int32  int
#define Int16  short
#define Int8   signed char
#define UInt32 unsigned int
#define UInt16 unsigned short
#define UInt8  unsigned char
#define int32  Int32
#define int16  Int16
#define int8   Int8
#define uint32 UInt32
#define uint16 UInt16
#define uint8  UInt8
#define NULL 0
#define EOF -1

typedef unsigned long Call68KFuncType(const void *emulStateP, unsigned long trapOrFunction, const void *argsOnStackP, unsigned long argsSizeAndwantA0);

#include "Armlet68k.h"

// manipulating r6
extern "C" {
uint32 GetR6();
void PutR6(uint32);
}
void *operator new(unsigned long);

UInt32 fread(void *, UInt32, UInt32, FILE *);
UInt32 fwrite(const void *, UInt32, UInt32, FILE *);
Int16 fgetc(FILE *);
Int16 fputc(UInt16, FILE *);
UInt32 feof(FILE *);
void fflush(FILE *);
void fclose(FILE *);

#define SEEK_SET 1
#define SEEK_CUR 2
#define SEEK_END 3

Int32 fseek(FILE *, Int32, UInt32);
UInt32 ftell(FILE *);
#define rewind(f) fseek(f, SEEK_SET, 0)

UInt32 sscanf(char *, char *, ...);
UInt32 fprintf(FILE *, char *, ...);

void *memcpy(void *, const void *, uint32);
void *memset(void *, int8, uint32);
char *strchr(char *, const char);
char *strncpy(char *, const char *, uint32);
char *strcpy(char *, const char *);
int16 strcmp(const char *, const char *);
int16 memcmp(const uint8 *, const uint8 *, uint32);
uint32 strlen(const char *);
int32 atoi(const char *);
char *strcat(char *, const char *);

char *hexfmt(uint32, uint16, char *);

#define M_PI 3.141592654

typedef unsigned long Call68KFuncType(const void *, unsigned long, const void *, unsigned long);

#include "Armlet68k.h"

#endif
